﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
<style type="text/css">
    .btnOkeh {
        float: right;
        margin-right: 5px;
        height: 5px !important;
    }

        .btnOkeh .dxbButton_IPPCSBlue .dxb {
            padding: 1px 3px 1px !important;
        }

            .btnOkeh .dxbButton_IPPCSBlue .dxb SPAN {
                height: 4px;
            }

            .btnOkeh .dxbButton_IPPCSBlue .dxb SPAN {
                font-size: 9px;
            }
</style>
<script type="text/javascript">
    $(document).ready(function () {
        //GridStatusOption.SetHeight(-180);
        getHeader();
        getShortageCount();
        $('#remKANBAN_ID_I, #remKANBAN_ID_ET').hide();
        $('#remMANIFEST_NO_I, #remMANIFEST_NO_ET').hide();
        $('#remORDER_NO_I, #remORDER_NO_ET').hide();
        $('#remPART_NO_I, #remPART_NO_ET').hide();
    });

    function OnBeginCallbackGrid(s, e) {
       var suppliercd = "";
        if (SupplierOption.GetText() != "") {
            suppliercd = SupplierOption.GetText();
            suppliercd = suppliercd.substring(0, 4);
        }
        e.customArgs["DELIVERY_NO"] = DELIVERY_NO.GetText();
        e.customArgs["ORDER_NO"] = ORDER_NO.GetText();
        e.customArgs["RCV_PLANT_CD"] = RECEIVING_PLANT.GetText();
        e.customArgs["DOCK_CD"] = DockOption.GetText();
        e.customArgs["ROUTE"] = RouteOption.GetText();
        e.customArgs["RIT"] = RIT.GetText();
        e.customArgs["SUPPLIER_CD"] = suppliercd;
        e.customArgs["P_LANE_SEQ"] = P_LANE_NO.GetText();
        e.customArgs["MANIFEST_NO"] = MANIFEST_NO.GetText();
        e.customArgs["DATE_FROM"] = ARRIVAL_DATE_FROM.GetText();
        e.customArgs["DATE_TO"] = ARRIVAL_DATE_TO.GetText();
        e.customArgs["KANBAN_NO"] = KANBAN_NO.GetText();
        e.customArgs["STATUS"] = StatusOption.GetText();
    }

    function getShortageCount()
    {
        var x = DELIVERY_NO.GetText();
        var STATUS = null;
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/KanbanSummaryPartReceiving/getShortage")",
            data:
            {
                //ORDER_NO: x.substring(1, x.length - 2),
                //DOCK_CD: DOCK_CD.GetText(),
                //RCV_PLANT_CD: RECEIVING_PLANT.GetText(),
                //SUPPLIER_CD: SUPPLIER_CD.GetText(),
                //P_LANE_CD: P_LANE_CD.GetText(),
                //KANBAN_NO: KANBAN_NO.GetText()

            },
            success: function (result) {
                if (result.data[0].RECEIVED == result.data[0].ORDER_PLAN_QTY_LOT) {
                    lblStatus.textContent = "Completed";
                }
                else {
                    lblStatus.textContent = "Shortage";
                }

            },
            error: function (result) {
                $.msgBox({ title: "error", type:"error", content: "Error when loading data" });
            }
        });

    }

    function getHeader()
    {
        var x = DELIVERY_NO.GetText();
        //RouteOption.SetText("");
        $.ajax(
             {
                 type: "POST",
                 url: "@Url.Content("~/KanbanSummaryPartReceiving/getKanbanReceivingHeader")",
            data:
        {
            //DELIVERY_NO: DELIVERY_NO.GetText(),
            //DOCK_CD: DOCK_CD.GetText(),
            //RCV_PLANT_CD: RECEIVING_PLANT.GetText(),
            //SUPPLIER_CD: SUPPLIER_CD.GetText(),
            //P_LANE_CD: P_LANE_CD.GetText()
        },
        success: function (result) {
            //lblRoute.textContent = result.data[0].ROUTE;
            //lblRit.textContent = result.data[0].RATE;
            //lblTruckStation.textContent = result.data[0].TRUCK_STATION;
            //lblOrderNo.textContent = x.substring(1, x.length - 2);
            //lblManifestNo.textContent = result.data[0].MANIFEST_NO;
            //lblArrivalPlan.textContent = result.data[0].ARRIVAL_PLAN_DT;
            //lblArrivalActual.textContent = result.data[0].ARRIVAL_ACTUAL_DT;
            //lblDeparturePlan.textContent = result.data[0].DEPARTURE_PLAN_DT;
            //lblDepartureActual.textContent = result.data[0].DEPARTURE_ACTUAL_DT;

        },
        error: function (result) {
            $.msgBox({ title: "error", type: "error", content: "Error when update data" });
        }
      });
    }

    function search() {
        //lblRoute.textContent = "";
        //lblRit.textContent = "";
        //lblTruckStation.textContent = "";
        //lblOrderNo.textContent = "";
        //lblStatus.textContent = "";
        //lblManifestNo.textContent = "";
        //getHeader();
        //getShortageCount();
        GridKanbanPartShortage.PerformCallback();
    }


    function clear() {
        RECEIVING_PLANT.SetText("");
        GridDockOption.UnselectRows();
        GridRouteOption.UnselectRows();
        DELIVERY_NO.SetText("");
        RIT.SetText("");
        GridSupplierOption.UnselectRows();
        P_LANE_NO.SetText("");
        ORDER_NO.SetText("");
        GridStatusOption.UnselectRows();
        MANIFEST_NO.SetText("");
        KANBAN_NO.SetText("");
        ARRIVAL_DATE_FROM.SetText("");
        ARRIVAL_DATE_TO.SetText("");
        GridKanbanPartShortage.ClearFilter();
    }
    
    function download(s, e) {
        var x = DELIVERY_NO.GetText();
        if (x != "") {
            x = x.substring(1, x.length - 2);
        }
        else {
            x = "";
        }
        var suppliercd = "";
        if (SupplierOption.GetText() != "") {
            suppliercd = SupplierOption.GetText();
            suppliercd = suppliercd.substring(0, 4);
        }
            $.fileDownload("KanbanPartShortage/DownloadKanbanPartShortage", {
                data: {
                    DELIVERY_NO : x,
                    ORDER_NO:ORDER_NO.GetText(),
                    RCV_PLANT_CD:RECEIVING_PLANT.GetText(),
                    DOCK_CD:DockOption.GetText(),
                    ROUTE: RouteOption.GetText(),
                    RIT:RIT.GetText(),
                    SUPPLIER_CD:suppliercd,
                    P_LANE_SEQ:P_LANE_NO.GetText(),
                    MANIFEST_NO: MANIFEST_NO.GetText(),
                    DATE_FROM:ARRIVAL_DATE_FROM.GetText(),
                    DATE_TO:ARRIVAL_DATE_TO.GetText(),
                    KANBAN_NO:KANBAN_NO.GetText(),
                    STATUS:StatusOption.GetText()
                 },
                 successCallback: function (result) {
                     //GoodsReceiptInquiryProgressPopup.Hide();
                 },
                 failCallback: function (result) {
                     //GoodsReceiptInquiryProgressPopup.Hide();

                     alert("Error On Download Kanban Part Shortage Data.");
                 }
             });
    }

    function trims(str) {
        return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
    }

    function saveNotes(index, KANBAN_ID, MANIFEST_NO, ORDER_NO, PART_NO)
    {
            var isError1 = 0;
            var isError2 = 0;
            var isError3 = 0;
            var isError4 = 0;

        
            var N = window["txtSA_Notes["+index+"]"].GetText();
        
            var a = N.split(".");
            var b = N.split(",");
            var c = N.split("?");
            var d = N.split("!");


            for(i=0;i<a.length-1;i++)
            {
                if(a[i].length==0)
                {
                    isError1=1;
                }
            }

            for(i=0;i<b.length-1;i++)
            {
                if(b[i].length==0)
                {
                    isError2=1;
                }
            }

            for(i=0;i<c.length-1;i++)
            {
                if(c[i].length==0)
                {
                    isError3=1;
                }
            }

            for(i=0;i<d.length-1;i++)
            {
                if(d[i].length==0)
                {
                    isError4=1;
                }
            }

        
            if(N=="" || trims(N)=="" || isError1==1 || isError2==1 || isError3==1 || isError4==1)
            {
                $.msgBox({ title: "Warning", type:"alert", content:"Please fill the note" });
                window["txtSA_Notes["+index+"]"].SetText("");
            }
            else
            {

                $.ajax(
                {
                    type: "POST",
                    url: "@Url.Content("~/KanbanPartShortage/saveRemark")",
                    data:
                {
                    KANBAN_ID : KANBAN_ID, 
                    MANIFEST_NO : MANIFEST_NO, 
                    ORDER_NO: ORDER_NO,
                    PART_NO : PART_NO,
                    REMARK : N
                },
                dataType:"JSON",
                success: function (result) {
                    if (result.status == 'success')
                        $.msgBox({ title: "Info", type:"info", content:result.message });
                    else
                        $.msgBox({ title: "Warning", type:"warning", content:result.message });

                    GridKanbanPartShortage.ClearFilter();
                }
            });

        }

    }


    function remark(KANBAN_NO, MANIFEST_NO, ORDER_NO, PART_NO)
    {
        
        //console.log(KANBAN_ID + '-' + MANIFEST_NO + '-' + ORDER_NO.trim() + '-' + PART_NO);
        remKANBAN_ID.SetText(KANBAN_NO);
        remMANIFEST_NO.SetText(MANIFEST_NO);
        remORDER_NO.SetText(ORDER_NO);
        remPART_NO.SetText(PART_NO);
        getRemark();
        popupnew.SetHeaderText('Add remark');
        popupnew.Show();
        
    }
    function remarkSave() {
        $.ajax(
        {
            type: "POST",
            url: "@Url.Content("~/KanbanPartShortage/saveRemark")",
            data:
        {
            KANBAN_NO: remKANBAN_ID.GetText(),
            MANIFEST_NO: remMANIFEST_NO.GetText(),
            ORDER_NO: remORDER_NO.GetText(),
            PART_NO: remPART_NO.GetText(),
            REMARK: REMARK.GetText()
        },
            dataType: "JSON",
            success: function (result) {
                if (result.status == 'success') {
                    remKANBAN_ID.SetText("");
                    remMANIFEST_NO.SetText("");
                    remORDER_NO.SetText("");
                    remPART_NO.SetText("");
                    REMARK.SetText("");
                    popupnew.Hide();
                    $.msgBox({ title: "Info", type: "info", content: result.message });
                }
                else {
                    remKANBAN_ID.SetText("");
                    remMANIFEST_NO.SetText("");
                    remORDER_NO.SetText("");
                    remPART_NO.SetText("");
                    REMARK.SetText("");
                    popupnew.Hide();
                    $.msgBox({ title: "Warning", type: "warning", content: result.message });
                }

                //GridKanbanPartShortage.ClearFilter();
            }
        });
    }

    function getRemark()
    {
            $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/KanbanPartShortage/getRemark")",
                data:
                {
                    KANBAN_NO: remKANBAN_ID.GetText(),
                    MANIFEST_NO: remMANIFEST_NO.GetText(),
                    ORDER_NO: remORDER_NO.GetText(),
                    PART_NO: remPART_NO.GetText()
                },
            dataType: "JSON",
            success: function (result) {
                REMARK.SetText(result.remark);
            }
        });
    }

    function remarkCancel()
    {
        remKANBAN_ID.SetText("");
        remMANIFEST_NO.SetText("");
        remORDER_NO.SetText("");
        remPART_NO.SetText("");
        REMARK.SetText("");
        popupnew.Hide();
    }

     var _PART_NO_DETAIL;
    var _KANBAN_NO_DETAIL;
    var _PART_NAME_DETAIL;
    var _KANBAN_QTY_DETAIL;
    var _ORDER_NO_DETAIL;
    var _KANBAN_ID_DETAIL;
    var _SUPPLIER_PLANT_CD_DETAIL;

    function OpenPrint(KANBAN_NO, ORDER_NO, PART_NO, KANBAN_ID, PART_NAME, SUPPLIER_PLANT_CD) {
        _KANBAN_ID_DETAIL = KANBAN_ID;
        _PART_NO_DETAIL = PART_NO;
        _KANBAN_NO_DETAIL = KANBAN_NO;
        _PART_NAME_DETAIL = PART_NAME;
        _KANBAN_QTY_DETAIL = 1
        _ORDER_NO_DETAIL = ORDER_NO;
        _SUPPLIER_PLANT_CD_DETAIL = SUPPLIER_PLANT_CD;
        popupDetailPartDetail.Show();
        PART_NO_DETAIL.SetText(_PART_NO_DETAIL);
        PART_NAME_DETAIL.SetText(_PART_NAME_DETAIL);
        KANBAN_NO_DETAIL.SetText(_KANBAN_NO_DETAIL);
        KANBAN_QTY_DETAIL.SetText(_KANBAN_QTY_DETAIL);
        SUPPLIER_PLANT_CD_DETAIL.SetText(_SUPPLIER_PLANT_CD_DETAIL);
        GridOrderPrintingdetailPartPartialDetail.PerformCallback();
    }

    function OnBeginCallbackGrids(s, e) {
        e.customArgs["ORDER_NO"] = _ORDER_NO_DETAIL;
        e.customArgs["PART_NO"] = _PART_NO_DETAIL;
        e.customArgs["KANBAN_NO"] = _KANBAN_NO_DETAIL;
    }
    

    function PrintKanbanWeb()
    {
        var x = GridOrderPrintingdetailPartPartialDetail.GetSelectedKeysOnPage();
        var kbn_id = '';
        for(i=0; i < x.length; i++)
        {
            kbn_id += x[i]+';';
        }

        kbn_id = kbn_id.substring(0,kbn_id.length-1);

        console.log(kbn_id);

        $.ajax({
            type: "POST",
            url: "@Url.Content("~/DailyOrderPrinting/PrintKanbanWeb")",
            async: false,
        data: {
            ORDER_NO : _ORDER_NO_DETAIL,
            PART_NO : _PART_NO_DETAIL,
            KANBAN_NO : _KANBAN_NO_DETAIL,
            KBN_ID: kbn_id,
            SUPPLIER_PLANT_CD : SUPPLIER_PLANT_CD_DETAIL.GetText()
        },
        success: function (result) {
            console.log(result.url);
            var url = result.url;
            url = url.replace('ippcs-qa/', '');
            console.log(url);
                    
            $.fileDownload(url,{
                       
                successCallback : function(url){
                    popupProgress.Hide();
                },
                failCallback : function(responseHtml, url){
                    popupProgress.Hide();
                    alert(responseHtml);
                }
            });  


            // ExecutePrintInFrame(result);
        },
        error: function (result) {
            //alert("Error when update data");
        }
    });
    }

    function CheckChange()
    {
        //console.log('oioi');
        GridKanbanPartShortage.PerformCallback();
    }

    function receive()
    {
        var KanbanNo = "";
        var error = 0;
        
        var getSelected = GridKanbanPartShortage.GetSelectedRowCount();

        if (getSelected > 0)
        {
                for (i = 0; i < GridKanbanPartShortage.cpEndIndex; i++)
                {
                    if(GridKanbanPartShortage.cpIsRowSelected[i]==true)
                    {
                        if (parseInt(+window["txtReceive[" + i + "]"].GetText()) > parseInt(GridKanbanPartShortage.cpShortage[i])) {
                            error = 1;
                            KanbanNo = KanbanNo+GridKanbanPartShortage.cpKanbanNo[i]+",";
                        }
                    }
                }
                KanbanNo = KanbanNo.substr(0, KanbanNo.length - 1);
                var text = "Received amount is too big compared to the shortage amount at KANBAN_NO : " + KanbanNo;
        
                if(error!=1)
                {
                    count = 0;
                    for(i=0;i<GridKanbanPartShortage.cpEndIndex;i++)
                    {
                        if(GridKanbanPartShortage.cpIsRowSelected[i]==true)
                        {
                            $.ajax(
                            {
                                type: "POST",
                                url: "@Url.Content("~/KanbanPartShortage/Receive")",
                                data:
                            {
                                RECEIVE : parseInt(window["txtReceive[" + i + "]"].GetText()),
                                KANBAN_NO: GridKanbanPartShortage.cpKanbanNo[i],
                                PART_NO: GridKanbanPartShortage.cpPartNo[i],
                                MANIFEST_NO: GridKanbanPartShortage.cpManifestNo[i]
                            },
                            dataType: "JSON",
                            success: function (result) {
                           
                           
                            }
                        }).done(function (result) {


                            if (result.status == "success")
                            {
                                count += 1;
                                console.log(count);
                            }

                            console.log("Selected : " + GridKanbanPartShortage.GetSelectedRowCount());
                            console.log("Count : " + count);
                            if (count == GridKanbanPartShortage.GetSelectedRowCount()) {
                                $.msgBox({ title: "Info", type: "info", content: "Receiving process has been completed", afterClose: function () { GridKanbanPartShortage.UnselectRows();  } });
                            }
                       
                        });
                    }

                }

           


            }
            else {
                $.msgBox({ title: "Warning", type: "warning", content:text});
            }
        }
        else
        {
            $.msgBox({ title: "Warning", type: "warning", content: "Please select one or more record" });
        }
        
    }



   

</script>
<div style="display: table; border: 1px solid #142B94; background-color: #DEECFD;
    padding: 10px; ">
    @Html.Action("PartialHeader", "KanbanPartShortage")
</div>



    <div id="circle" class="circle">&nbsp;</div>
    </div>

    <div style="height: 3px;">
    </div>

    @* div spacing *@
   <div style=" display: table; width: 100%; margin-right: 10px; ">
    @Html.Action("PartialData", "KanbanPartShortage")

    </div>


@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupnew";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(400);
    //settings.Height = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Modal = true;
    settings.ShowPageScrollbarWhenModal = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.SetContent(() =>
    {
        Html.RenderPartial("RemarkForm");
    });
}).GetHtml()


@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupDetailPartDetail";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(600);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(600);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    //settings.ClientSideEvents.Shown = "OnShowHandlerDetailPartDetail";
    settings.SetContent(() =>
    {
        Html.RenderPartial("HeaderDetailPartDetail");
    });
}).GetHtml()